//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Server.ConnectionConfiguration
{
    
    
    /// <summary>
    /// A class that exposes the IConnectionConfigurationService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ConnectionConfigurationServiceProvider : IFeatureProvider
    {
        
        private IConnectionConfigurationService _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(ConnectionConfigurationServiceProvider).Assembly, "ConnectionConfigurationService.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public ConnectionConfigurationServiceProvider(IConnectionConfigurationService implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<EnableServerInitiatedConnectionModeRequestDto, EmptyRequest>("EnableServerInitiatedConnectionMode", EnableServerInitiatedConnectionMode);
            registration.RegisterUnobservableCommand<DisableServerInitiatedConnectionModeRequestDto, EmptyRequest>("DisableServerInitiatedConnectionMode", DisableServerInitiatedConnectionMode);
            registration.RegisterUnobservableCommand<ConnectSiLAClientRequestDto, EmptyRequest>("ConnectSiLAClient", ConnectSiLAClient);
            registration.RegisterUnobservableCommand<DisconnectSiLAClientRequestDto, EmptyRequest>("DisconnectSiLAClient", DisconnectSiLAClient);
            registration.RegisterUnobservableProperty("ServerInitiatedConnectionModeStatus", GetServerInitiatedConnectionModeStatus);
            registration.RegisterUnobservableProperty("ConfiguredSiLAClients", GetConfiguredSiLAClients);
        }
        
        /// <summary>
        /// Executes the Enable Server Initiated Connection Mode command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest EnableServerInitiatedConnectionMode(EnableServerInitiatedConnectionModeRequestDto request)
        {
            request.Validate();
            _implementation.EnableServerInitiatedConnectionMode();
            return EmptyRequest.Instance;
        }
        
        /// <summary>
        /// Executes the Disable Server Initiated Connection Mode command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest DisableServerInitiatedConnectionMode(DisableServerInitiatedConnectionModeRequestDto request)
        {
            request.Validate();
            _implementation.DisableServerInitiatedConnectionMode();
            return EmptyRequest.Instance;
        }
        
        /// <summary>
        /// Executes the Connect SiLA Client command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest ConnectSiLAClient(ConnectSiLAClientRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.ConnectSiLAClient(request.ClientName.TryExtract(_server, "org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                            "/Parameter/ClientName"), request.SiLAClientHost.TryExtract(_server, "org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                            "/Parameter/SiLAClientHost"), request.SiLAClientPort.TryExtract(_server, "org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                            "/Parameter/SiLAClientPort"), request.Persist.TryExtract(_server, "org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                            "/Parameter/Persist"));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "clientName"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                            "/Parameter/ClientName", ex.Message);
                }
                if ((ex.ParamName == "siLAClientHost"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                            "/Parameter/SiLAClientHost", ex.Message);
                }
                if ((ex.ParamName == "siLAClientPort"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                            "/Parameter/SiLAClientPort", ex.Message);
                }
                if ((ex.ParamName == "persist"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                            "/Parameter/Persist", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Disconnect SiLA Client command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest DisconnectSiLAClient(DisconnectSiLAClientRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.DisconnectSiLAClient(request.ClientName.TryExtract(_server, "org.silastandard/core/ConnectionConfigurationService/v1/Command/DisconnectSiLACli" +
                            "ent/Parameter/ClientName"), request.Remove.TryExtract(_server, "org.silastandard/core/ConnectionConfigurationService/v1/Command/DisconnectSiLACli" +
                            "ent/Parameter/Remove"));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "clientName"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/ConnectionConfigurationService/v1/Command/DisconnectSiLACli" +
                            "ent/Parameter/ClientName", ex.Message);
                }
                if ((ex.ParamName == "remove"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/ConnectionConfigurationService/v1/Command/DisconnectSiLACli" +
                            "ent/Parameter/Remove", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Server Initiated Connection Mode Active property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.BooleanDto> GetServerInitiatedConnectionModeStatus()
        {
            return new PropertyResponse<Tecan.Sila2.BooleanDto>(new Tecan.Sila2.BooleanDto(_implementation.ServerInitiatedConnectionModeStatus, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Get Configured SiLA Clients property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<System.Collections.Generic.List<ConfiguredSiLAClientDto>> GetConfiguredSiLAClients()
        {
            return new PropertyResponse<System.Collections.Generic.List<ConfiguredSiLAClientDto>>(Tecan.Sila2.DtoExtensions.Encapsulate(_implementation.ConfiguredSiLAClients, ConfiguredSiLAClientDto.Create, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/core/ConnectionConfigurationService/v1/Command/EnableServerIniti" +
                "atedConnectionMode"))
            {
                return typeof(IConnectionConfigurationService).GetMethod("EnableServerInitiatedConnectionMode");
            }
            if ((commandIdentifier == "org.silastandard/core/ConnectionConfigurationService/v1/Command/DisableServerInit" +
                "iatedConnectionMode"))
            {
                return typeof(IConnectionConfigurationService).GetMethod("DisableServerInitiatedConnectionMode");
            }
            if ((commandIdentifier == "org.silastandard/core/ConnectionConfigurationService/v1/Command/ConnectSiLAClient" +
                ""))
            {
                return typeof(IConnectionConfigurationService).GetMethod("ConnectSiLAClient");
            }
            if ((commandIdentifier == "org.silastandard/core/ConnectionConfigurationService/v1/Command/DisconnectSiLACli" +
                "ent"))
            {
                return typeof(IConnectionConfigurationService).GetMethod("DisconnectSiLAClient");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/core/ConnectionConfigurationService/v1/Property/ServerInitiatedC" +
                "onnectionModeStatus"))
            {
                return typeof(IConnectionConfigurationService).GetProperty("ServerInitiatedConnectionModeStatus");
            }
            if ((propertyIdentifier == "org.silastandard/core/ConnectionConfigurationService/v1/Property/ConfiguredSiLACl" +
                "ients"))
            {
                return typeof(IConnectionConfigurationService).GetProperty("ConfiguredSiLAClients");
            }
            return null;
        }
    }
}

